unit hiMT_Enum;

interface

uses Kol,Share,Debug;

type
  THIMT_Enum = class(TDebug)
   private
    FStop:boolean;
    Item:TData;
    Ind:integer;
   public
    _prop_Type:byte;

    _data_MT:THI_Event;
    _event_onEndEnum:THI_Event;
    _event_onItem:THI_Event;

    procedure _work_doEnum(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _var_Item(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
  end;

implementation


procedure THIMT_Enum._work_doEnum;
Var p: PData;
    l: PList;
    k: integer;
    MT:TData;
begin
  FStop := false;
  mt:=ReadData(_Data, _data_MT, nil);

  if mt.data_type=data_null then exit;
  l:=NewList;
  p:=@mt;
  while p <> nil do
    begin l.Add(p); p := p.ldata; end;
  if _prop_Type = 0 then begin
     k := 1;
     Ind := 0;
   end else begin
     k := -1;
     Ind := l.Count-1;
  end;
    
  while not FStop and (ind>=0) and (ind<l.Count) do
    begin
     dtData(item,PData(l.items[ind])^);
     _hi_OnEvent(_event_onItem,item);
     inc(Ind,k);
    end;
  _hi_OnEvent(_event_onEndEnum);
  l.free;
end;

procedure THIMT_Enum._work_doStop;
begin
  FStop := true;
end;

procedure THIMT_Enum._var_Item;
begin
  dtData(_Data,Item);
end;

procedure THIMT_Enum._var_Index;
begin
  dtInteger(_Data,Ind);
end;

end.
